unit Demo4a;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, Grids, DBGrids, StdCtrls,
  ExtCtrls, DBCtrls, vim32, V32Sess;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    VimSession1: TVimSession;
    DBGrid1: TDBGrid;
    Button1: TButton;
    DBNavigator1: TDBNavigator;
    Memo1: TMemo;
    rg: TRadioGroup;
    lbx1: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure rgClick(Sender: TObject);
  private
    { Private declarations }
    procedure errShow;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Demo1s1;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
const
  sAt: Pchar = 'at ';
  arrEl: longInt = 8;
type
  sName        = array [0..0] of VimString;
  sNamePtr     = ^sName;
  ref          = array [0..0] of VimRef;
  refPtr       = ^ref;
  sComments    = array [0..0] of vimString;
  sCommentsPtr = ^sComments;
  vAddress     = array [0..0] of vimAddress;
  vAddressPtr  = ^vAddress;

var
  psName     : VimString;
  subtreeRef : vimRef;
  pPos       : vimEnumRef;        {starting position input}
  attrCount  : vimWord;           {count attributes input}
  pAddrAttr  : array[0..3] of vimAttrDesc; {attribute(s) to get input}
  pNameAttr  : array[0..3] of vimAttrDesc; {attribute(s) to get input}
  pGrpAttr   : array[0..3] of vimAttrDesc; {attribute(s) to get input}
  pCount     : vimWord;                    {max attributes input}
  pMore      : vimBool;                    {true if more returned}
{
  sName      : array [0..0] of VimString;
  ref        : array [0..0] of VimRef;
  sComments  : array [0..0] of vimString;
  vAddress   : array [0..0] of vimAddress;
}
  PtrName     : sNamePtr;
  PtrRef      : refPtr;
  PtrComments : sCommentsPtr;
  PtrAddress  : vAddressPtr;
  sLocation  : string[1];
  s          :string;
  p          :PChar;
  entType    : vimSelector;
  vwLocation : vimWord;
  gEntType   : vimSelector;
  gRef       : vimRef;
  gName      : vimString;
  i          :integer;
  curs       :TCursor;
  FAddressBook : VimAddressBook;
begin
        strpcopy(psName, 'Directory');
        VimSession1.vimError := VIMOpenAddressBook(VimSession1.session, @psName, FAddressBook);
        if not VimSession1.checkVimStatus('Open Address book-Directory') then
          exit;
        {
          Now allocate the memory for the extracted address book entries
        }
        pCount := 30;
        while pCount > 0 do begin
          try
            GetMem(PtrName, pCount * sizeOf(vimString));
          except
            on EOutOfMemory do begin
              dec(pCount);
              continue;
            end;
          end;
          try
            GetMem(PtrRef, pCount * sizeOf(vimRef));
          except
            on EOutOfMemory do begin
              freeMem(PtrName);
              dec(pCount);
              continue;
            end;
          end;
          try
            GetMem(PtrComments, pCount * sizeOf(vimString));
          except
            on EOutOfMemory do begin
              freeMem(PtrName);
              freeMem(PtrRef);
              dec(pCount);
              continue;
            end;
          end;
          try
            GetMem(PtrAddress, pCount * sizeOf(vimAddress));
          except
            on EOutOfMemory do begin
              freeMem(PtrName);
              freeMem(PtrRef);
              freeMem(PtrComments);
              dec(pCount);
              continue;
            end;
          end;
          break;
        end;
        if pCount = 0 then
          raise EOutOfMemory.create('Unable to allocate memory for address list');
        try
          { Now enumerate the entity entries in this address book }
          VIM_UND_REF(subTreeRef);
          pAddrAttr[0].Attr   := VIMSEL_NAME;
          pAddrAttr[0].size   := sizeOf(vimSTring);
          pAddrAttr[0].buffer := PtrName;
          pAddrAttr[1].Attr   := VIMSEL_ADDRESS;
          pAddrAttr[1].size   := sizeOf(vimAddress);
          pAddrAttr[1].buffer := PtrAddress;
          pAddrAttr[2].Attr   := VIMSEL_REF;
          pAddrAttr[2].size   := sizeOf(vimRef);
          pAddrAttr[2].buffer := PtrRef;
          pAddrAttr[3].Attr   := VIMSEL_COMMENTS;
          pAddrAttr[3].size   := sizeOf(vimString);
          pAddrAttr[3].buffer := PtrComments;
          pNameAttr[0].Attr   := VIMSEL_TYPE;
          pNameAttr[0].size   := sizeOf(entType);
          pNameAttr[0].buffer := @entType;
          pNameAttr[1].Attr   := VIMSEL_LOCATION;
          pNameAttr[1].size   := sizeOf(vimWord);
          pNameAttr[1].buffer := @vwLocation;
          pGrpAttr[0].Attr   := VIMSEL_NAME;
          pGrpAttr[0].size   := sizeOf(gName);
          pGrpAttr[0].buffer := @gName;
          pGrpAttr[1].Attr   := VIMSEL_TYPE;
          pGrpAttr[1].size   := sizeOf(vimSelector);
          pGrpAttr[1].buffer := @gEntType;
          pGrpAttr[2].Attr   := VIMSEL_REF;
          pGrpAttr[2].size   := sizeOf(vimRef);
          pGrpAttr[2].buffer := @gRef;
          pMore := TRUE;
          pCount := 30;
          attrCount := {4}2;
          pPos := 0;

          { First enumerate the entity values from the address book }
          while pMore do begin
            screen.cursor := crHourGlass;
            VimSession1.vimError := VIMEnumerateAddressBookEntries(
                                        FAddressBook, {addr book handle input}
                                        subtreeRef,   {node identifier input}
                                        nil,          {node name input}
                                        pPos,         {starting position input}
                                                      {enum ref number returned}
                                        1,            {entries to skip input}
                                        attrCount,    {count attributes input}
                                        pAddrAttr[0], {attribute(s) to get input}
                                                      {attribute(s) returned}
                                        pCount,       {max attributes input}
                                                      {actual no. returned}
                                        VIMSEL_ENTITY,{filter type input}
                                        nil,          {filter data input}
                                        pMore         {true if more returned}
                                       );
            if VimSession1.vimError <> 0 then
              if not VimSession1.checkVimStatus('Enumerate address book entries') then
                exit;
            if pCount <> 0 then begin
              for i := 0 to pred(pCount) do begin
                screen.cursor := crHourGlass;
                application.processMessages;
                {
                Session.vimError := VIMGetAbEntryAttributes(FAddressBook,
                                                            PtrRef[i],
                                                            nil,
                                                            2,
                                                            pNameAttr[0]);
                if not Session.checkVimStatus('Enumerate address book entries attributes') then
                  exit;
                case vwLocation of
                  VIMSEL_LOCAL               : sLocation := 'L';
                  VIMSEL_DIALIN              : sLocation := 'R';
                  VIMSEL_REMOTE              : sLocation := 'r';
                  VIMSEL_ALIAS               : sLocation := 'a';
                  VIMSEL_DIRECT_POSTOFFICE   : sLocation := 'P';
                  VIMSEL_INDIRECT_POSTOFFICE : sLocation := 'p';
                else
                  sLocation := '?'
                end;
                p := StrPos(PtrAddress[i].value, sAt);
                if (p <> nil) then begin
                  strMove(p,'',1);
                  p := p + 3;
                  s := strpas(PtrAddress[i].value);
                end else                    }
                  p := PtrAddress[i].value;
                lbx1.items.add(p);
                screen.cursor := curs;
                application.processMessages;
              end; { for }
            end; {pCount <> 0 }
            screen.cursor := curs;
            application.processMessages;
          end; {while }
        finally
          freeMem(PtrName);
          freeMem(PtrRef);
          freeMem(PtrComments);
          freeMem(PtrAddress);
        end;

{
begin
   if not VimSession1.active then begin
     VimSession1.active := true;
     if not vimSession1.active then begin
       errShow;
       exit;
     end;
   end;

   if DBVimAddressBook1.active = true then
     DBVimAddressBook1.active := false;
   rg.itemindex := 0;
   Datasource1.enabled := false;
   DBVimAddressBook1.active := true;
   DBVimAddressBook1.activeAddressBook := 'Directory';
   Datasource1.enabled := true;
   if vimsession1.vimError <> 0 then
     errShow;
}
end;

procedure TForm1.rgClick(Sender: TObject);
begin
  case rg.itemindex of
    0: Table1.indexname := '';
    1: Table1.indexname := 'byName';
    2: Table1.indexname := 'byAddressAndName';
  end;
end;

procedure TForm1.errShow;
begin
  with Vimsession1 do begin
    errorDlg.errorMessage.text := errorMessage;
    errorDlg.extendedError.text := extendedError;
    errorDlg.applicationError.text := applicationError;
    errorDlg.showModal;
  end;
end;

end.
